"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.recursiveFixAnyOf = exports.removeStringFromArray = exports.writeFile = void 0;
const fs = require("fs");
const writeFile = (filepath, content) => {
    return new Promise((resolve, reject) => {
        fs.writeFile(filepath, content, (err) => {
            if (err) {
                console.error(err);
                reject();
                return;
            }
            resolve(true);
        });
    });
};
exports.writeFile = writeFile;
function removeStringFromArray(arr, value) {
    let i = 0;
    while (i < arr.length) {
        if (arr[i] === value)
            arr.splice(i, 1);
        else
            ++i;
    }
    return arr;
}
exports.removeStringFromArray = removeStringFromArray;
const recursiveFixAnyOf = (definition) => {
    var _a;
    if (definition.type === 'object') {
        return Object.entries((_a = definition.properties) !== null && _a !== void 0 ? _a : {}).reduce((acc, [propertyKey, def]) => {
            if (propertyKey === 'anyOf') {
                // fix it
                acc.enum = def.anyOf.map((anyOfObj) => anyOfObj.const);
            }
            acc.properties[propertyKey] = (0, exports.recursiveFixAnyOf)(def);
            return acc;
        }, Object.assign(Object.assign({}, definition), { properties: {} }));
    }
    return definition;
};
exports.recursiveFixAnyOf = recursiveFixAnyOf;
